/***************************************************************************/
/*                                                                         */
/*  File: Game.cpp                                                         */
/*  Date: 06-02-07                                                         */
/*                                                                         */
/***************************************************************************/
/*
	Main Game File - This is where we update all our elements in the game
	do any creation of things, such as land, tanks and call render
	on them all or update....heart of the whole game is here.

*/
/***************************************************************************/


#include <math.h>		// cosf(..) sinf(..), sqrt(..)
#include <stdio.h>      // sprintf(..)
//#include <windows.h>	// Windows


#include <d3dx9.h>
#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")

//#pragma comment(lib, "d3d8.lib")					// DirectX Library Files
//#pragma comment(lib, "d3dx8.lib")
//#include <d3dx8.h>								// DirectX Header File

#include "Shapes.h"		// Simple DX Shape Drawing Functions


// DirectX Device/Render Handles
extern LPDIRECT3D9			g_pD3D;			// main.cpp
extern LPDIRECT3DDEVICE9	g_pD3DDevice;	// main.cpp

// Globals
float		g_timeStep		= 1.0f;					// Timing 

/***************************************************************************/

bool Create()
{

	return true;
}// End Create

/***************************************************************************/

bool Release()
{

	return true;
}// End Release()



/***************************************************************************/
/*                                                                         */
/*  Name: KeyBoard()                                                       */
/*                                                                         */
/*  Used to accept keyboard input and alter some global variables - used   */
/*  for simple analysis of our code - turning wire frame rendering on/off  */
/*  adjusting variables which are used in the demo.                        */
/*                                                                         */
/***************************************************************************/
static void KeyBoard()
{
	// Controlling the rendering
	//if( GetKeyState('W')		& 0x80 ) g_bWire=!g_bWire;
/*
	// Controlling movement
	float speed = 2.8f * g_timeStep;
	g_force = 0.0f;
	if( GetKeyState(VK_RIGHT)	& 0x80 )  g_roty-=speed;
	if( GetKeyState(VK_LEFT)	& 0x80 )  g_roty+=speed;

	if( GetKeyState(VK_UP)		& 0x80 )  g_force = 5.0f; //g_vel=min(g_vel+speed,  1.3f);
	if( GetKeyState(VK_DOWN)	& 0x80 )  g_force = -5.0f; //g_vel=max(g_vel-speed, -1.3f);
*/
}//End KeyBoard()


static void UpdateTiming()
{
	// We use a more accurate timing information, QueryPerformanceCounter
	// instead of GetTickCount() so we get smoother animations
	LARGE_INTEGER freq;
	QueryPerformanceFrequency(&freq);

	LARGE_INTEGER nTime;
	QueryPerformanceCounter(&nTime);

	static LARGE_INTEGER oTime = nTime;

	double delay = (double(nTime.QuadPart - oTime.QuadPart)/freq.QuadPart);
	oTime=nTime;

	g_timeStep = (float)delay;

	//g_timeStep = g_timeStep / 4.0f;

	if (g_timeStep > 0.2f)
	{
		g_timeStep = 0.2f;
	}

}


void SetCamera()
{
	extern bool  g_LMousePress;
	extern bool  g_RMousePress;
	extern int	 g_mousePosX;
	extern int   g_mousePosY;
	extern int   g_zoom;

	float s = 0.02f;
	D3DXVECTOR3 vMove = D3DXVECTOR3((float)g_mousePosX*s, (float)g_mousePosY*s, 0);

	static D3DXVECTOR3 vDir			= D3DXVECTOR3(0, 0, -20);
	static D3DXVECTOR3 vDirOld		= vDir;


	/*
	if (g_LMousePress)
	{
		D3DXMATRIX rot;
		D3DXMatrixRotationYawPitchRoll(&rot, vMove.x, vMove.y, 0);
		D3DXVec3TransformCoord(&vDir, &vDirOld, &rot);
	}
	else
	{
		vDirOld = vDir;
	}
	*/


	
	static D3DXVECTOR3 vLookAt		= D3DXVECTOR3(0,0,0);
	D3DXVECTOR3 vCamPosition		= vLookAt + vDir;

    // [1] D3DTS_VIEW
    D3DXMATRIX v;
    g_pD3DDevice->SetTransform(	D3DTS_VIEW, 
								D3DXMatrixLookAtLH(&v, 
								&vCamPosition, 
                                &vLookAt, 
                                &D3DXVECTOR3(0,1,0)));  

	float aa = 1;
	float bb = -1;
    // [2] D3DTS_PROJECTION
    D3DXMATRIX p = D3DXMATRIX( 1, 0, 0,  0,
							   0, 1, 0,  0,
							   0, 0, aa, 1,
							   0, 0, bb, 0 );

	D3DXMATRIX pv;
	D3DXMatrixPerspectiveFovLH( &pv,  
								D3DX_PI/4,  
								1.0f,
                                1.0f,1000.0f);

	/*
    g_pD3DDevice->SetTransform( D3DTS_PROJECTION, 
								D3DXMatrixPerspectiveFovLH( &p,  
								D3DX_PI/4,  
								1.0f,
                                1.0f,1000.0f));
								*/

	g_pD3DDevice->SetTransform( D3DTS_PROJECTION, &pv);

	int jjjj = 2;
}//End SetCamera(..)



void CreatePickRay(D3DXVECTOR3* pos, D3DXVECTOR3* dir)
{
	D3DXVECTOR3 v;
	POINT ptCursor;
	GetCursorPos(&ptCursor);
	extern HWND	g_hwnd;
	ScreenToClient(g_hwnd, &ptCursor);

	D3DXMATRIX matView, matProj;
	g_pD3DDevice->GetTransform( D3DTS_VIEW,			&matView);
	g_pD3DDevice->GetTransform( D3DTS_PROJECTION,	&matProj);

	RECT rect;
	GetClientRect(g_hwnd, &rect);
	v.x =  (((2.0f*ptCursor.x)/rect.right)-1.0f)/matProj._11;
	v.y = -(((2.0f*ptCursor.y)/rect.bottom)-1.0f)/matProj._22;
	v.z = 1.0f;

	D3DXMATRIX matViewI;
	D3DXMatrixInverse(&matViewI, NULL, &matView);

	dir->x = v.x*matViewI._11 + v.y*matViewI._21 + v.z*matViewI._31;
	dir->y = v.x*matViewI._12 + v.y*matViewI._22 + v.z*matViewI._32;
	dir->z = v.x*matViewI._13 + v.y*matViewI._23 + v.z*matViewI._33;

	pos->x = matViewI._41;
	pos->y = matViewI._42;
	pos->z = matViewI._43;

	D3DXVec3Normalize(dir, dir);
}//End CreatePickRay(..)


void DrawCross(IDirect3DDevice9* pDevice, D3DXVECTOR3 p, const D3DXMATRIX& mat)
{
	float s = 5.0f;
	DrawLine(pDevice, D3DXVECTOR3(p.x-s,0,    0    ), D3DXVECTOR3(p.x+s,0,    0    ), 0xffff0000, mat);
	DrawLine(pDevice, D3DXVECTOR3(0,    p.y-s,0    ), D3DXVECTOR3(0,    p.y+s,0    ), 0xff00ff00, mat);
	DrawLine(pDevice, D3DXVECTOR3(0,    0,    p.z-s), D3DXVECTOR3(0,    0,    p.z+s), 0xff0000ff, mat);
}//End DrawCross(..)

/***************************************************************************/

void ExtractAnglesXYZ(D3DXMATRIX& mat, float& x, float& y, float& z)
{
	float siny = mat._13;
	float cosy = sqrtf(1.0f - (siny*siny));
	float sinx = -mat._23 / cosy;
	float cosx =  mat._33 / cosy;
	float sinz = -mat._12 / cosy;
	float cosz =  mat._11 / cosy;

	y = -atan2f(siny, cosy);
	x = -atan2f(sinx, cosx);
	z = -atan2f(sinz, cosz);


}// End ExtractAnglesXYZ(..)



/***************************************************************************/
/*                                                                         */
/* GameLoop()                                                              */
/* Our main render loop, which gets called over and over agian to do our   */
/* drawing...clears the screen, draws the data, then presents it..         */
/*                                                                         */
/***************************************************************************/
void GameLoop()
{
	UpdateTiming();

	KeyBoard();

	SetCamera();

	// Clear the back buffer to a blue color
	g_pD3DDevice->Clear( 0, 
						 NULL, 
						 D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, 
						 D3DCOLOR_XRGB(90,100,90), 
						 1.0f, 
						 0 );

	g_pD3DDevice->BeginScene();




	//DrawCube(	g_pD3DDevice, 
	//			D3DXVECTOR3(0,0,0), 		
	//			D3DXVECTOR3(0,0,0), 
	//			D3DXVECTOR3(2,2,2));



	//DrawLine(	g_pD3DDevice,
	//			D3DXVECTOR3(-5,0,0),
	//			D3DXVECTOR3(+5,0,0));

	static float totalTime = 0.0f;
	totalTime+=g_timeStep;
	static char buf[256] = {0};
	sprintf(buf, "Running (%.1f)....\n", totalTime);
	DrawText(g_pD3DDevice, buf);

	D3DXVECTOR3 p, d;
	CreatePickRay(&p, &d);


	//D3DXVECTOR3 s(0.01f,0,0);
	D3DXVECTOR3 s(0,0.01f,0);
	DrawLine(g_pD3DDevice, p+d, p+200.0f*(d+s));



/*
	bool hit = 
	RayCircleHit(	D3DXVECTOR3(0,0,0), 
					D3DXVECTOR3(0,0,0), 
					D3DXVECTOR3(3,3,3),
					10.0f);
*/

	extern bool  g_LMousePress;
	extern bool  g_RMousePress;


	enum 
	{
		X_ROT,
		Y_ROT,
		Z_ROT,
		NO_ROT
	};
	static int XYZ_ROT = NO_ROT;

	bool selectable = true;

	if (g_LMousePress)
	{
		selectable = false;
	}
	else
	{
		XYZ_ROT = NO_ROT;
	}
	


	static D3DXVECTOR3 vRot = D3DXVECTOR3(0,0,0);
	
	sprintf(buf, "vRot (%.2f, %.2f, %.2f)...\n", vRot.x, vRot.y, vRot.z);
	DrawText(g_pD3DDevice, buf, 10, 25);


	static D3DXVECTOR3 vTempRot = vRot;
	


	if (selectable)
	{
		vTempRot=vRot;
	}

	D3DXVECTOR3 vRotVal = vRot - vTempRot;

	sprintf(buf, "vRotDiff (%.2f, %.2f, %.2f)...\n", vRotVal.x, vRotVal.y, vRotVal.z);
	DrawText(g_pD3DDevice, buf, 10, 40);


	

	
	

	
	static D3DXMATRIX matWorld = D3DXMATRIX(1,0,0,0,  0,1,0,0,  0,0,1,0,  0,0,0,1);
	D3DXMATRIX matRot;
	D3DXMatrixRotationYawPitchRoll(&matRot, vRotVal.y, vRotVal.x, vRotVal.z);

	static D3DXMATRIX matCube = matRot * matWorld;

	if (selectable==false)
	{
		matCube = matRot * matWorld;
	}
	else
	{
		matWorld = matCube;
	}







	bool hit =
	DrawCircle(	g_pD3DDevice,
				D3DXVECTOR3(0,0,0),
				matCube,
				D3DXVECTOR3(3,3,3),
				0xffff0000,
				0xff222222,
				selectable);
	if (hit)
	{
		XYZ_ROT = Y_ROT;
	}

	hit =
	DrawCircle(	g_pD3DDevice,
				D3DXVECTOR3(0,0,0),
				matCube,
				D3DXVECTOR3(3,3,3),
				0xff0000ff,
				0xff222222,
				selectable,
				D3DXVECTOR3(0,0,D3DX_PI/2.0f));

	if (hit)
	{
		XYZ_ROT = X_ROT;
	}

	hit =
	DrawCircle(	g_pD3DDevice,
				D3DXVECTOR3(0,0,0),
				matCube,
				D3DXVECTOR3(3,3,3),
				0xff00ff00,
				0xff222222,
				selectable,
				D3DXVECTOR3(D3DX_PI/2.0f,0,0));

	if (hit)
	{
		XYZ_ROT = Z_ROT;
	}

	extern bool  g_LMousePress;
	extern bool  g_RMousePress;
	extern int	 g_mousePosX;
	extern int   g_mousePosY;
	extern int   g_zoom;

	float scale = 0.02f;
	D3DXVECTOR3 vMove = D3DXVECTOR3((float)g_mousePosX*scale, (float)g_mousePosY*scale, 0);
	static D3DXVECTOR3 vOldMove = vMove;
	
	static D3DXVECTOR3 vOldRot  = vRot;

	

	if (selectable==false)
	{
		switch (XYZ_ROT)
		{
			case X_ROT:
			{
				float diff = vOldMove.x - vMove.x;
				vRot.x = vOldRot.x + diff;
			}
			break;

			case Y_ROT:
			{
				float diff = vOldMove.x - vMove.x;
				vRot.y = vOldRot.y + diff;
			}
			break;

			case Z_ROT:
			{
				float diff = vOldMove.x - vMove.x;
				vRot.z = vOldRot.z + diff;
			}
			break;
		}
	}
	else
	{
		vOldMove = vMove;
		vOldRot  = vRot;
	}


	DrawCube(	g_pD3DDevice, 
				D3DXVECTOR3(0,0,0), 		
				D3DXVECTOR3(0,0,0), 
				D3DXVECTOR3(2,2,2),
				matCube);


	int hh = 14;
	int h  = 50;
	sprintf(buf, "Mat:");
	DrawText(g_pD3DDevice, buf, 10, h+=12);
	char* val = "    [%.2f\t   %.2f\t   %.2f\t   %.2f]";

	sprintf(buf, val, matCube._11, matCube._12, matCube._13, matCube._14);
	DrawText(g_pD3DDevice, buf, 10, h+=hh);
	sprintf(buf, val, matCube._21, matCube._22, matCube._23, matCube._24);
	DrawText(g_pD3DDevice, buf, 10, h+=hh);
	sprintf(buf, val, matCube._31, matCube._32, matCube._33, matCube._34);
	DrawText(g_pD3DDevice, buf, 10, h+=hh);
	sprintf(buf, val, matCube._41, matCube._42, matCube._43, matCube._44);
	DrawText(g_pD3DDevice, buf, 10, h+=hh);

	float xang, yang, zang;
	xang = yang = zang = 0.0f;
	ExtractAnglesXYZ(matCube, xang, yang, zang);

	h+=10;
	sprintf(buf, "angles: %.2f, %.2f, %.2f", xang, yang, zang);
	DrawText(g_pD3DDevice, buf, 10, h+=hh);


	
	D3DXMATRIX matx, maty, matz;
	D3DXMatrixRotationX(&matx, xang);
	D3DXMatrixRotationY(&maty, yang);
	D3DXMatrixRotationZ(&matz, zang);
	matCube = matx * maty * matz;


	DrawCube(	g_pD3DDevice, 
				D3DXVECTOR3(4,4,0), 		
				D3DXVECTOR3(0,0,0), 
				D3DXVECTOR3(1,1,1),
				matCube);


	DrawCross(g_pD3DDevice, D3DXVECTOR3(0,0,0), matCube);

	g_pD3DDevice->EndScene();
	// After rendering the scene we display it.
	g_pD3DDevice->Present( NULL, NULL, NULL, NULL );


}//End Update()




