/***************************************************************************/
/*                                                                         */
/*  File: Shapes.h                                                         */
/*  Date: 10-03-07                                                         */
/*                                                                         */
/***************************************************************************/
/*

*/
/***************************************************************************/
#ifndef SHAPES_H
#define SHAPES_H


#include <d3dx9.h>				// Direct X Header Files

								// Direct X Library Files
#pragma comment(lib, "d3d9.lib")	
#pragma comment(lib, "d3dx9.lib")



// Simple Function To Draw a Cube in the 3D World
void DrawCube(IDirect3DDevice9  * pDevice, 
			  const D3DXVECTOR3& pos, 
			  const D3DXVECTOR3& rot, 
			  const D3DXVECTOR3& dim,
			  const D3DXMATRIX&  world = D3DXMATRIX(1,0,0,0, 0,1,0,0,  0,0,1,0,  0,0,0,1));


// Simple 3D Line Drawing Function
void DrawLine(IDirect3DDevice9  * pDevice, 
			  const D3DXVECTOR3& from,
		      const D3DXVECTOR3& to,
			  unsigned int col = 0xffff00ff,
			  const D3DXMATRIX& mat = D3DXMATRIX(1,0,0,0, 0,1,0,0,  0,0,1,0,  0,0,0,1));


bool DrawCircle(IDirect3DDevice9  * pDevice, 
				const D3DXVECTOR3& pos, 
				const D3DXMATRIX&  world, 
				const D3DXVECTOR3& dim,
				unsigned int col    = 0xffff0000,
				unsigned int colhit = 0xff222222,
				bool selectable     = true,
				const D3DXVECTOR3& localrot =D3DXVECTOR3(0,0,0));



void DrawText(IDirect3DDevice9 * pDevice,
				char * str, 
				int xpos = 10, 
				int ypos = 10, 
				unsigned int argb = 0xffffffff,
				int size =15);


void DrawLine2D(  IDirect3DDevice9  * pDevice, 
				  D3DXVECTOR2 from,
				  D3DXVECTOR2 to,
				  unsigned  int col = 0xffffffff );


bool RayCircleHit(  const D3DXVECTOR3& pos, 
					const D3DXMATRIX& rot, 
					const D3DXVECTOR3& dim,
					float checkBorder,
					const D3DXVECTOR3& localrot = D3DXVECTOR3(0,0,0));

#endif //SHAPES_H